#ifndef __creature_def__
#define __creature_def__
#include <allegro.h>
#include "global.h"

const int ANum = 100;
const real VMin = 0.0, VMax = 1.0, VDelta = 0.05, ADelta = M2PI / ANum;
enum Types {TYPE_BUILDER, TYPE_MONSTER, TYPE_NUM};
enum AIs {AI_NONE, AI_RANDOM, AI_COWARD, AI_AGGRESSIVE, AI_NEUTRAL, AI_NUM};

struct creature
{
 real x, y, z, v, a, s, w;
 int type, ai, control_flags;

 creature (real nx, real ny, real nv, real na, real ns, int ntype, int nai);

 void accelerate (void);
 void brake (void);
 void turn_left (void);
 void turn_right (void);

 void move (void);
 bool check (void);
 void control (void);
 void effect (void);
 bool suffer (void);
 void draw (void);
};

void normalize (real & angle);
bool inside (int x, int y);
void recur_effect_up (int x, int y);
void recur_effect_down (int x, int y);
#endif // __creature_def__
