#include <cmath>
#include <cstdio>
#include <cstdlib>
#include "random.h"
const int MBIG = 1000000000, MSEED = 161803398;
const real FAC = 1.0 / MBIG;

int inext, inextp;
int ra [56];

int nextrand (void)
{
 int j;
 if (++inext == 56) inext = 1;
 if (++inextp == 56) inextp = 1;
 j = ra[inext] - ra[inextp];
 if (j < 0) j += MBIG;
 ra[inext] = j;
 return j;
}

bool initrand (int seed)
{
 int i, j, k, l;
 l = MSEED - seed;
 if (l < 0) l = -l;
 l %= MBIG;
 ra[55] = l;
 k = 1;
 for (i = 1, j = 0; i <= 54; i++)
 {
  j += 21;
  if (j > 55) j -= 55;
  ra[j] = k;
  k = l - k;
  if (k < 0) k += MBIG;
  l = ra[j];
 }
 for (k = 1; k <= 4; k++)
  for (i = 1, j = 31; i <= 55; i++, j >= 55 ? j = 1 : j++)
  {
   ra[i] -= ra[j];
   if (ra[i] < 0) ra[i] += MBIG;
  }
 inext = 0;
 inextp = 31;
 return true;
}

real rndvalue (void)
{
 return nextrand () * FAC;
}

int rndvalue (int k)
{
 return (int) floor (rndvalue () * k);
}

void init_random (void)
{
 FILE * f;
 int k;
 if ((f = fopen (frnd_name, "rt")) == NULL)
 {
  k = 0;
 }
 else
 {
  fscanf (f, "%d", &k);
  fclose (f);
 }
 f = fopen (frnd_name, "wt");
 fprintf (f, "%d\n", k + 1);
 fclose (f);
 if (!initrand (k))
 {
  printf ("Random init (%d) failed!\n", k);
  exit (EXIT_FAILURE);
 }
 printf ("Started with random init %d.\n", k);
 fflush (stdout);
}
