#include <cassert>
#include <cstdio>
#include <cstring>
#include "score.h"

int ch_score [MaxCh] [MaxScore];
int lv_score [MaxLv] [MaxScore];
char ch_sname [MaxCh] [MaxScore] [MaxInput];
char lv_sname [MaxLv] [MaxScore] [MaxInput];

extern char name [MaxInput];

void load_score (void)
{
 char buf [MaxBuf];
 FILE * f;
 int i, j;
 char ch;

 memset (ch_score, MaxC, sizeof (ch_score));
 memset (ch_sname, 0, sizeof (ch_sname));
 if ((f = fopen (f_ch_score_name, "rt")) != NULL)
 {
  for (i = 0; i < MaxCh; i++)
   for (j = 0; j < MaxScore; j++)
   {
    fscanf (f, "%d%c", &ch_score[i][j], &ch);
    assert (ch == ' ');
    fgets (buf, MaxInput, f);
    if (buf[strlen (buf) - 1] == '\n')
     buf[strlen (buf) - 1] = '\0';
    strcpy (ch_sname[i][j], buf);
   }
  fclose (f);
  printf ("Challenge high scores loaded.\n");
 }
 else
 {
  printf ("Challenge high scores not found.\n");
 }
 fflush (stdout);
 for (i = 0; i < MaxCh; i++)
  for (j = 0; j < MaxScore; j++)
   if (!strcmp (ch_sname[i][j], ""))
    strcpy (ch_sname[i][j], "none");

 memset (lv_score, MaxC, sizeof (lv_score));
 memset (lv_sname, 0, sizeof (lv_sname));
 if ((f = fopen (f_lv_score_name, "rt")) != NULL)
 {
  for (i = 0; i < MaxLv; i++)
   for (j = 0; j < MaxScore; j++)
   {
    fscanf (f, "%d%c", &lv_score[i][j], &ch);
    assert (ch == ' ');
    fgets (buf, MaxInput, f);
    if (buf[strlen (buf) - 1] == '\n')
     buf[strlen (buf) - 1] = '\0';
    strcpy (lv_sname[i][j], buf);
   }
  fclose (f);
  printf ("Level high scores loaded.\n");
 }
 else
 {
  printf ("Level high scores not found.\n");
 }
 fflush (stdout);
 for (i = 0; i < MaxLv; i++)
  for (j = 0; j < MaxScore; j++)
   if (!strcmp (lv_sname[i][j], ""))
    strcpy (lv_sname[i][j], "none");
}

void save_score (void)
{
 FILE * f;
 int i, j;
 if ((f = fopen (f_ch_score_name, "wt")) != NULL)
 {
  for (i = 0; i < MaxCh; i++)
   for (j = 0; j < MaxScore; j++)
    fprintf (f, "%d %s\n", ch_score[i][j], ch_sname[i][j]);
  fclose (f);
  printf ("Challenge high scores saved.\n");
 }
 else
 {
  printf ("Challenge high scores could not be saved!\n");
 }
 fflush (stdout);

 if ((f = fopen (f_lv_score_name, "wt")) != NULL)
 {
  for (i = 0; i < MaxLv; i++)
   for (j = 0; j < MaxScore; j++)
    fprintf (f, "%d %s\n", lv_score[i][j], lv_sname[i][j]);
  fclose (f);
  printf ("Level high scores saved.\n");
 }
 else
 {
  printf ("Level high scores could not be saved!\n");
 }
 fflush (stdout);
}

int insert_ch_score (int level, int score)
{
 int i, j;
 for (j = 0; j < MaxScore; j++)
  if (ch_score[level][j] > score)
  {
   for (i = MaxScore - 2; i >= j; i--)
   {
    ch_score[level][i + 1] = ch_score[level][i];
    strcpy (ch_sname[level][i + 1], ch_sname[level][i]);
   }
   ch_score[level][j] = score;
   strcpy (ch_sname[level][j], name);
   return j;
  }
 return -1;
}

int insert_lv_score (int level, int score)
{
 int i, j;
 for (j = 0; j < MaxScore; j++)
  if (lv_score[level][j] > score)
  {
   for (i = MaxScore - 2; i >= j; i--)
   {
    lv_score[level][i + 1] = lv_score[level][i];
    strcpy (lv_sname[level][i + 1], lv_sname[level][i]);
   }
   lv_score[level][j] = score;
   strcpy (lv_sname[level][j], name);
   return j;
  }
 return -1;
}
